/*
	$Id: Method.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   ؿǤ

   methodǤбޤ
*/
public class Method {

    /** name° */
    private String name;

    /** ¤Τޤ϶Τ˽°Ϥ̾ */
    private String parentName;

    /** Υå */
    private Parameters params;

    /** ҤΥå */
    private Modifiers modifiers;

    /**  */
    private Return returnElem;

    /** ܺ */
    private Description desc;

    /**
       ؿޤ

       @param parentName °빽¤Τޤ϶Τ̾
       @param elem method
    */
    public Method(final String parentName, final Element elem) {
	this.parentName = parentName;
	name = elem.getAttribute("name");

	ChildrenFilter c = new ChildrenFilter(elem);
	params = new Parameters(c.getDirectChildrenByTagName("param"));
	modifiers = new Modifiers(c.getDirectChildrenByTagName("modifier"));
	returnElem = new Return(c.getDirectChildrenByTagName("return"));
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       name°ͤޤ

       @return name°
    */
    public String getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	String opener = "";
	String closer = ";";
	String pre = "";
	String post = "";
	printPrototype(wr, opener, closer, pre, post);
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	String opener = "extern ";
	String closer = ";";
	String pre = "(*stub_";
	String post = ")";
	printPrototype(wr, opener, closer, pre, post);
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	String returns = returnElem.getText().equals("void") ? "" : "return ";
	wr.println("");
	printPrototype(wr, "", " = NULL;", "(*stub_", ")");
	printPrototype(wr, "", "", "", "");
	wr.print("{\n"
		 + "    if (stub_" + name + " == NULL)\n"
		 + "        abort();\n"
		 + "    " + returns + "stub_" + name + "(");

	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "" : p.getName();
	wr.print(arg);
	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(", " + p.getName());
	}

	wr.print(");\n");
	wr.print("}\n");
    }

    /**
       ץȥϤޤ

       @param wr 饤
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
    */
    private void printPrototype(final PrintWriter wr, final String opener,
				final String closer,
				final String pre, final String post) {
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getCode();
	String s = opener + returnElem.getLeftCode() + pre + name + post + "(";
	int len = s.length();
	char[] space = new char[len];
	for (int i = 0; i < len; ++i) {
	    space[i] = ' ';
	}
	String offset = new String(space);
	wr.print(s + arg);
	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(",\n" + offset + p.getCode());
	}
	wr.println(")" + returnElem.getRightCode()
		   + modifiers.getCode() + closer);
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	String prefix = "";
	String pre = "";
	String post = "";
	IDManager m = IDManager.getInstance();

	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + m.getString(returnElem.getText())
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ pre + "<a href=\"#" + prefix + name + "\"><b>" + name + "</b></a>"
+ post + "(" + m.getString(params.getText()) + ") "
+ m.getString(modifiers.getCode()) + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	String prefix = "";
	String pre = "";
	String post = "";
	IDManager m = IDManager.getInstance();
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : m.getString(p.getText());

	wr.print(""
+ "<p><a name=\"" + prefix + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + m.getString(returnElem.getText()) + " "
                    + pre + "<b>" + name + "</b>" + post + "(</td>\n"
+ "    <td nowrap>" + arg);

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(""
+ ",</td>\n"
+ "  </tr>\n"
+ "  <tr>\n"
+ "    <td></td><td nowrap>" + m.getString(p.getText()));
	}
	wr.println(""
+ ") " + m.getString(modifiers.getCode()) + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	params.printDetail(wr);
	returnElem.printDetail(wr);

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	Parameter p = params.getParameter(0);
	String texName = Tex.safe(name);
	String arg, lf, indent;

	if (p == null) {
	    arg = "void";
	    lf = "";
	    indent = "";
	} else {
	    arg = p.getTexText();
	    lf = "\\\\\n";
	    indent = "\\Sindent ";
	}

	// Syntax
	wr.println("");
	wr.println("\\Sid{" + texName + "}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.print(returnElem.getTexText() + " {\\bfseries " + texName + "}("
		 + lf + indent + arg);

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.println(",\\\\");
	    wr.println(indent);
	    wr.print(p.getTexText());
	}
	wr.println(")");
	wr.println("\\end{Ssyntax}");

	// Description
	wr.print(desc.getTexText());

	// Parameters
	params.printTexDetail(wr);

	// Returns
	returnElem.printTexDetail(wr);
    }
}
